// -*- C++ -*- generated by wxGlade 0.6.5 on Sun Sep 23 22:52:41 2012

#include <wx/wx.h>
#include <wx/image.h>
// begin wxGlade: ::dependencies
// end wxGlade

#include <vector>
#include <string>

#ifndef CHOICEKEYFRAMEDIALOG_H
#define CHOICEKEYFRAMEDIALOG_H


// begin wxGlade: ::extracode
enum
{
	ID_TEXT_FRAME,
	ID_COMBO_CHOICE
};
// end wxGlade


class ChoiceKeyFrameDialog: public wxDialog {
public:
	// begin wxGlade: ChoiceKeyFrameDialog::ids
	// end wxGlade

	ChoiceKeyFrameDialog(wxWindow* parent, int id, const wxString& title, const wxPoint& pos=wxDefaultPosition, const wxSize& size=wxDefaultSize, long style=wxDEFAULT_DIALOG_STYLE);

	//Set the choices that are allowed to be selected
	void setChoices(const std::vector<std::string> &choices,size_t defaultChoice=0);

	//Obtain the choice from the user
	size_t getChoiceIndex() const { return choice;};
	
	std::string getChoice() const { return choiceStrings[choice];};

	size_t getStartFrame() const { return startFrame;}
private:
	// begin wxGlade: ChoiceKeyFrameDialog::methods
	void set_properties();
	void do_layout();
	// end wxGlade

	//List of choices that can go into the combo box
	std::vector<std::string> choiceStrings;

	//Drop-down value chosen by user
	size_t choice;

	//True if the start frame entered by user is valid
	bool startFrameOK;

	//Current start frame
	size_t startFrame;

	//enable or disable the OK button based upon validation results
	void updateOKButton();

	//build up the combo box items
	void buildCombo(size_t defaultChoice);
protected:
	// begin wxGlade: ChoiceKeyFrameDialog::attributes
	wxStaticText* labelFrame;
	wxTextCtrl* textFrame;
	wxStaticText* labelSelection;
	wxComboBox* comboChoice;
	wxButton* btnCancel;
	wxButton* btnOK;
	// end wxGlade

	DECLARE_EVENT_TABLE();

public:
	virtual void OnChoiceCombo(wxCommandEvent &event); // wxGlade: <event_handler>
	virtual void OnFrameText(wxCommandEvent &event); // wxGlade: <event_handler>
}; // wxGlade: end class


#endif // CHOICEKEYFRAMEDIALOG_H
