// -*- C++ -*- generated by wxGlade 0.6.5 on Fri Sep 14 09:37:57 2012

#include "colourKeyFrameDialog.h"
#include "../../basics.h"
#include "../../wxcommon.h"
#include "../../translation.h"

#include <wx/colordlg.h>

#include <string>

using std::string;

// begin wxGlade: ::extracode
enum{
	ID_COMBO_TRANSITION,
	ID_BTN_START_VALUE,
	ID_BTN_FINAL_VALUE,
	ID_TEXT_INITIAL_VALUE,
	ID_TEXT_FRAME_START,
	ID_TEXT_FRAME_END
};

// end wxGlade

//FIXME: Is currently duplicated from realKeyframeDialog. Needs to be
// unified
enum
{
	TRANSITION_STEP,
	TRANSITION_INTERP,
	TRANSITION_END
};


ColourKeyFrameDialog::ColourKeyFrameDialog(wxWindow* parent, int id, const wxString& title, const wxPoint& pos, const wxSize& size, long style):
	wxDialog(parent, id, title, pos, size, wxDEFAULT_DIALOG_STYLE|wxRESIZE_BORDER|wxMAXIMIZE_BOX|wxMINIMIZE_BOX)
{
	// begin wxGlade: ColourKeyFrameDialog::ColourKeyFrameDialog
	sizerMainArea_staticbox = new wxStaticBox(this, -1, wxTRANS("Keyframe Data"));
	labelTransition = new wxStaticText(this, wxID_ANY, wxTRANS("Transition"));
	//FIXME: THis is declared in animator.h - use that def.
	const wxString comboTransition_choices[] = {
        wxTRANS("Step"),
        wxTRANS("Ramp")
    };
	comboTransition = new wxComboBox(this, ID_COMBO_TRANSITION, _(""), wxDefaultPosition, wxDefaultSize, 2, comboTransition_choices, wxCB_DROPDOWN|wxCB_READONLY);
	labelFrameStart = new wxStaticText(this, wxID_ANY, wxTRANS("Start Frame"), wxDefaultPosition, wxDefaultSize, wxALIGN_RIGHT);
	textFrameStart = new wxTextCtrl(this, ID_TEXT_FRAME_START, wxEmptyString);
	labelFrameEnd = new wxStaticText(this, wxID_ANY, wxTRANS("End Frame"), wxDefaultPosition, wxDefaultSize, wxALIGN_RIGHT);
	textFrameEnd = new wxTextCtrl(this, ID_TEXT_FRAME_END, wxEmptyString);
	verticalLine = new wxStaticLine(this, wxID_ANY, wxDefaultPosition, wxDefaultSize, wxLI_VERTICAL);
	labelStartVal = new wxStaticText(this, wxID_ANY, wxTRANS("Initial Value"), wxDefaultPosition, wxDefaultSize, wxALIGN_RIGHT);
	btnStartColour = new wxButton(this, ID_BTN_START_VALUE, wxTRANS("startColour"), wxDefaultPosition, wxDefaultSize, wxBU_EXACTFIT);
	labelFinalVal = new wxStaticText(this, wxID_ANY, wxTRANS("Final Value"), wxDefaultPosition, wxDefaultSize, wxALIGN_RIGHT);
	btnEndColour = new wxButton(this, ID_BTN_FINAL_VALUE, wxTRANS("endColour"), wxDefaultPosition, wxDefaultSize, wxBU_EXACTFIT);
	buttonCancel = new wxButton(this, wxID_CANCEL, wxEmptyString);
	buttonOK = new wxButton(this, wxID_OK, wxEmptyString);

	comboTransition->SetSelection(1);
	transitionMode=TRANSITION_INTERP;
	endFrameOK=startFrameOK=false;
	startRed=startGreen=startBlue=0;		
	endRed=endGreen=endBlue=0;		


	updateOKButton();
	updateButtonColours();

	set_properties();
	do_layout();
	// end wxGlade
}


BEGIN_EVENT_TABLE(ColourKeyFrameDialog, wxDialog)
	// begin wxGlade: ColourKeyFrameDialog::event_table
	EVT_COMBOBOX(ID_COMBO_TRANSITION, ColourKeyFrameDialog::OnComboTransition)
	EVT_TEXT(ID_TEXT_FRAME_START, ColourKeyFrameDialog::OnTextStartFrame)
	EVT_TEXT(ID_TEXT_FRAME_END, ColourKeyFrameDialog::OnTextEndFrame)
	EVT_BUTTON(ID_BTN_START_VALUE, ColourKeyFrameDialog::OnBtnStartColour)
	EVT_BUTTON(ID_BTN_FINAL_VALUE, ColourKeyFrameDialog::OnBtnEndColour)
	// end wxGlade
END_EVENT_TABLE();

std::string ColourKeyFrameDialog::getEndValue() const 
{
	ASSERT(transitionMode!=TRANSITION_STEP);
	std::string s;
	genColString(endRed,endGreen,endBlue,s);
	return s;
}

std::string ColourKeyFrameDialog::getStartValue() const
{
	std::string s;
	genColString(startRed,startGreen,startBlue,s);
	return s;
}

void ColourKeyFrameDialog::OnComboTransition(wxCommandEvent &event)
{
	ASSERT(event.GetInt() < TRANSITION_END);

	transitionMode=event.GetInt();

	btnEndColour->Enable(transitionMode != TRANSITION_STEP);
	textFrameEnd->Enable(transitionMode!=TRANSITION_STEP);
}

void ColourKeyFrameDialog::OnTextStartFrame(wxCommandEvent &event)
{
	startFrameOK=validateTextAsStream(textFrameStart,startFrame);
	updateOKButton();
}


void ColourKeyFrameDialog::OnTextEndFrame(wxCommandEvent &event)
{
	endFrameOK=validateTextAsStream(textFrameEnd,endFrame);
	updateOKButton();
}


void ColourKeyFrameDialog::OnBtnStartColour(wxCommandEvent &event)
{
	wxColourData d;
	wxColourDialog *colDg=new wxColourDialog(this->GetParent(),&d);

	if( colDg->ShowModal() == wxID_OK)
	{
		wxColour c;
		//Change the colour
		c=colDg->GetColourData().GetColour();

		startRed=c.Red();
		startGreen=c.Green();
		startBlue=c.Blue();
		
		updateButtonColours();
	}
}


void ColourKeyFrameDialog::OnBtnEndColour(wxCommandEvent &event)
{
	wxColourData d;
	wxColourDialog *colDg=new wxColourDialog(this->GetParent(),&d);

	if( colDg->ShowModal() == wxID_OK)
	{
		wxColour c;
		//Change the colour
		c=colDg->GetColourData().GetColour();

		endRed=c.Red();
		endGreen=c.Green();
		endBlue=c.Blue();

		updateButtonColours();
	}

	colDg->Destroy();
}

void ColourKeyFrameDialog::updateOKButton()
{
	bool isOK=true;
	isOK&=startFrameOK;
	isOK&=endFrameOK;

	//Ensure start frame is > end frame
	if(isOK)
	{
		isOK&=(startFrame<endFrame);
		if(!isOK)
		{
			textFrameStart->SetBackgroundColour(*wxCYAN);
			textFrameEnd->SetBackgroundColour(*wxCYAN);
		}
		else
		{
			textFrameStart->SetBackgroundColour(wxNullColour);
			textFrameEnd->SetBackgroundColour(wxNullColour);
		}
	}
	
	buttonOK->Enable(isOK);
}

void ColourKeyFrameDialog::updateButtonColours()
{
	wxColour colD;
	colD.Set(startRed,startGreen,startBlue);
	btnStartColour->SetForegroundColour(colD);
	
	colD.Set(endRed,endGreen,endBlue);
	btnEndColour->SetForegroundColour(colD);

}
// wxGlade: add ColourKeyFrameDialog event handlers


void ColourKeyFrameDialog::set_properties()
{
	// begin wxGlade: ColourKeyFrameDialog::set_properties
	SetTitle(wxTRANS("Key Frame : Colour"));
	comboTransition->SetSelection(-1);
	btnStartColour->SetToolTip(wxTRANS("Colour at the start of the transtition"));
	btnEndColour->SetToolTip(wxTRANS("Colour at end of transition"));
	// end wxGlade
}


void ColourKeyFrameDialog::do_layout()
{
	// begin wxGlade: ColourKeyFrameDialog::do_layout
	wxBoxSizer* sizerTop = new wxBoxSizer(wxVERTICAL);
	wxBoxSizer* sizerBUttons = new wxBoxSizer(wxHORIZONTAL);
	wxStaticBoxSizer* sizerMainArea = new wxStaticBoxSizer(sizerMainArea_staticbox, wxHORIZONTAL);
	wxBoxSizer* sizerRight = new wxBoxSizer(wxVERTICAL);
	wxBoxSizer* sizerRightFinal = new wxBoxSizer(wxHORIZONTAL);
	wxBoxSizer* sizerRightInitial = new wxBoxSizer(wxHORIZONTAL);
	wxBoxSizer* sizerLeft = new wxBoxSizer(wxVERTICAL);
	wxBoxSizer* sizerEndFrame = new wxBoxSizer(wxHORIZONTAL);
	wxBoxSizer* sizerStartFrame = new wxBoxSizer(wxHORIZONTAL);
	wxBoxSizer* sizerTransition = new wxBoxSizer(wxHORIZONTAL);
	sizerTop->Add(20, 5, 0, 0, 0);
	sizerMainArea->Add(10, 20, 0, 0, 0);
	sizerLeft->Add(20, 10, 0, 0, 0);
	sizerTransition->Add(labelTransition, 0, wxRIGHT|wxALIGN_CENTER_VERTICAL, 14);
	sizerTransition->Add(comboTransition, 1, wxLEFT|wxALIGN_CENTER_VERTICAL, 5);
	sizerLeft->Add(sizerTransition, 1, wxEXPAND, 0);
	sizerStartFrame->Add(labelFrameStart, 0, wxRIGHT|wxALIGN_CENTER_VERTICAL, 5);
	sizerStartFrame->Add(textFrameStart, 1, wxLEFT|wxALIGN_CENTER_VERTICAL, 4);
	sizerLeft->Add(sizerStartFrame, 1, wxEXPAND|wxALIGN_CENTER_VERTICAL, 0);
	sizerEndFrame->Add(labelFrameEnd, 0, wxRIGHT|wxALIGN_CENTER_VERTICAL, 12);
	sizerEndFrame->Add(textFrameEnd, 1, wxLEFT|wxALIGN_CENTER_VERTICAL, 4);
	sizerLeft->Add(sizerEndFrame, 1, wxEXPAND|wxALIGN_CENTER_VERTICAL, 0);
	sizerLeft->Add(20, 10, 0, 0, 0);
	sizerMainArea->Add(sizerLeft, 2, wxEXPAND, 0);
	sizerMainArea->Add(verticalLine, 0, wxLEFT|wxRIGHT|wxEXPAND, 5);
	sizerRight->Add(20, 20, 1, 0, 0);
	sizerRightInitial->Add(20, 20, 1, 0, 0);
	sizerRightInitial->Add(labelStartVal, 2, wxRIGHT|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 0);
	sizerRightInitial->Add(btnStartColour, 0, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 3);
	sizerRightInitial->Add(20, 20, 1, 0, 0);
	sizerRight->Add(sizerRightInitial, 1, wxEXPAND|wxALIGN_CENTER_VERTICAL, 0);
	sizerRightFinal->Add(20, 20, 1, 0, 0);
	sizerRightFinal->Add(labelFinalVal, 2, wxRIGHT|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 9);
	sizerRightFinal->Add(btnEndColour, 0, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 3);
	sizerRightFinal->Add(20, 20, 1, 0, 0);
	sizerRight->Add(sizerRightFinal, 1, wxEXPAND|wxALIGN_CENTER_VERTICAL, 0);
	sizerRight->Add(20, 20, 1, 0, 0);
	sizerMainArea->Add(sizerRight, 2, wxEXPAND, 0);
	sizerMainArea->Add(10, 20, 0, 0, 0);
	sizerTop->Add(sizerMainArea, 1, wxEXPAND, 0);
	sizerBUttons->Add(20, 20, 1, 0, 0);
	sizerBUttons->Add(buttonCancel, 0, wxALL, 4);
	sizerBUttons->Add(buttonOK, 0, wxALL, 4);
	sizerTop->Add(sizerBUttons, 0, wxEXPAND, 0);
	SetSizer(sizerTop);
	sizerTop->Fit(this);
	Layout();
	// end wxGlade
}

