// -*- C++ -*- generated by wxGlade 0.6.5 on Thu Jun  7 12:47:44 2012

#include "autosaveDialog.h"
#include "../wxcommon.h"
#include "../translation.h"
// begin wxGlade: ::extracode

// end wxGlade



AutosaveDialog::AutosaveDialog(wxWindow* parent, int id, const wxString& title, const wxPoint& pos, const wxSize& size, long style):
    wxDialog(parent, id, title, pos, size, wxDEFAULT_DIALOG_STYLE|wxRESIZE_BORDER)
{

	selectedItem=(size_t)-1;
	haveRemovedItems=false;

    // begin wxGlade: AutosaveDialog::AutosaveDialog
    const wxString *listStates_choices = NULL;
    listStates = new wxListBox(this, ID_LIST_STATES, wxDefaultPosition, wxDefaultSize, 0, listStates_choices, wxLB_SINGLE|wxLB_NEEDED_SB);
    btnRemoveAll = new wxButton(this, ID_REMOVE_ALL, wxTRANS("Remove &All"));
    btnCancel = new wxButton(this, wxID_CANCEL, wxEmptyString);
    btnOK = new wxButton(this, wxID_OK, wxEmptyString);

    set_properties();
    do_layout();
    // end wxGlade
}


BEGIN_EVENT_TABLE(AutosaveDialog, wxDialog)
    // begin wxGlade: AutosaveDialog::event_table
    EVT_LISTBOX_DCLICK(ID_LIST_STATES, AutosaveDialog::OnListStatesDClick)
    EVT_LISTBOX(ID_LIST_STATES, AutosaveDialog::OnListStates)
    EVT_BUTTON(ID_REMOVE_ALL, AutosaveDialog::OnRemoveAll)
    EVT_BUTTON(wxID_CANCEL, AutosaveDialog::OnCancel)
    EVT_BUTTON(wxID_OK, AutosaveDialog::OnOK)
    // end wxGlade
END_EVENT_TABLE();

void AutosaveDialog::OnListStates(wxCommandEvent &event)
{
	//Get the first selected item
	selectedItem= listStates->GetSelection();
}

void AutosaveDialog::OnListStatesDClick(wxCommandEvent &event)
{
	EndModal(wxID_OK);
}


void AutosaveDialog::OnRemoveAll(wxCommandEvent &event)
{
	haveRemovedItems=true;	
	btnRemoveAll->Enable(false);
	listStates->Clear();
	listStates->Enable(false);
}


void AutosaveDialog::OnCancel(wxCommandEvent &event)
{
	EndModal(wxID_CANCEL);
}


void AutosaveDialog::OnOK(wxCommandEvent &event)
{
	EndModal(wxID_OK);
}


// wxGlade: add AutosaveDialog event handlers

void AutosaveDialog::setItems( const std::vector<std::string> &newItems)
{
	for(size_t ui=0;ui<newItems.size();ui++)
		listStates->Insert(wxStr(newItems[ui]),ui);
}

void AutosaveDialog::set_properties()
{
    // begin wxGlade: AutosaveDialog::set_properties
    SetTitle(wxTRANS("Restore state?"));
    // end wxGlade
}


void AutosaveDialog::do_layout()
{
    // begin wxGlade: AutosaveDialog::do_layout
    wxBoxSizer* sizer_1 = new wxBoxSizer(wxVERTICAL);
    wxBoxSizer* sizer_2 = new wxBoxSizer(wxHORIZONTAL);
    wxStaticText* labelHeader = new wxStaticText(this, wxID_ANY, wxTRANS("Multiple autosave states were found; would you like to restore one?"), wxDefaultPosition, wxDefaultSize, wxALIGN_CENTRE);
    sizer_1->Add(labelHeader, 0, wxALL|wxALIGN_CENTER_HORIZONTAL, 8);
    sizer_1->Add(listStates, 1, wxALL|wxEXPAND, 8);
    sizer_2->Add(btnRemoveAll, 0, wxLEFT|wxBOTTOM, 8);
    sizer_2->Add(20, 20, 1, 0, 0);
    sizer_2->Add(btnCancel, 0, wxLEFT|wxRIGHT|wxBOTTOM, 8);
    sizer_2->Add(btnOK, 0, wxRIGHT|wxBOTTOM, 8);
    sizer_1->Add(sizer_2, 0, wxEXPAND, 0);
    SetSizer(sizer_1);
    sizer_1->Fit(this);
    Layout();
    // end wxGlade
}

